<?

 /***************************************************************************************
 * Filename: automagic.php
 *
 * This file is part of the Photo album JAS plugin.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The Photo album JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/photoalbum/
 ***************************************************************************************/


 $startTime=microtime(true);

 $_path["root"]="../../../../../";
 require($_path["root"]."include.php");

 if($_session->inBackend()) //backend project
  $_session->frontend(); //switch to frontend project

 require_once($_path["include"]."data.php");
 require_once($_path["include"]."plugin.php");
 require_once($_path["format"]."template.php");

 //init average time
 if($_session->get("automagic")===NULL)
 {
  $_session->set("automagic.time", 0);
  $_session->set("automagic.weigth", 0);
 }

 //initialize plugin
 $plugin=new Plugin("photoalbum");

 if(!$plugin->isEnabled())
 {
  $plugin->e->add("Plugin ".$plugin->name." is disabled", "error");
  print $plugin->e->show();
  exit;
 }

 //initialize template
 $template=new Format_Template(false, false);

 if(!$template->read($plugin->path["templates"]."automagic.html"))
 {
  print $template->e->show();
  exit;
 }

 $values=Array();
 $values["url"]="";
 $values["file"]="";
 $values["timeout"]=10; //ms

 //handle request
 if($albums=request("pictures")) //auto add pictures
 {
  $d=Data::cache("photoalbum_pictures", "add", "item", Array("skipPostInit" => true));

  //init basic file filtering
  $d->unsetValue("nr");
  $d->unsetValue("catnr");
  $d->postInit();

  $total=0;
  $added=false;
  $current=false;
  $validAlbums=Array();
  foreach(explode(";", $albums) as $album)
  {
   if(preg_match("/^\d+$/", $album))
   {
    $validAlbums[]=$album;

    //get todo file list
    $d->setValue("catnr", $album);
    $d->moduleObject->setAlbumDirectoryAndUnpublished();

    $todo=$d->listOptions["file"];

    //get full file list
    $d->setFileDir("file", $d->field["file"]["localpath"]["directory"]);
    $all=$d->listOptions["file"];

    $total+=sizeof($all);

    if(!$added) //nothing added yet
    {
     if(!$todo) //all added for this album
     {
      $current+=sizeof($all);
      $catnr=$album; //set catnr for album title (below)
     }
     else //new images
     {
      //add first
      $d->setValue("file", $todo[0]);

      if(!$d->submit())
       $plugin->e->add($d->e);

      $values["file"]=$d->getValue("file");

      $current+=(sizeof($all)-sizeof($todo))+1;
      $catnr=$album; //set catnr for album title (below)
      $added=true; //done adding for this page load
     }
    }
   }
  }

  if($current==$total)
   $plugin->e->add("Photo album automagic done", "note");
  else
   $values["url"]=$_path["HTML"]["url"]."?pictures=".implode(";", $validAlbums);
 }
 else if($albums=request("albums")) //auto add albums
 {
  //determine what albums aren't added yet
  $d=Data::cache("photoalbum_categories", "tree", "down");
  $all=$d->listOptions["directory"];

  $d->setShowFields("directory");

  if($d->moduleObject->getCategory("container")==$albums) //container
  {
   $d->setValue("catnr", $albums);
   $d->get(); //get all albums

   $prefix=""; //no directory prefix
  }
  else //photoalbum
  {
   $d->unsetValue("catnr"); //ensure nr is used
   $d->setValue("nr", $albums);

   if(!$d->get()||!$d->vmax) //no results
    $plugin->e->add("Photo album automagic failed", "error", "Unknown album");
   else
    $prefix=$d->getValue("directory"); //get directory prefix
  }

  $catnr=$albums; //set catnr for album title (below)

  if(!$plugin->e->any("fatal"))
  {
   $todo=Array();
   foreach($all as $album)
   {
    if(!$prefix||strpos($album, $prefix)===0)
     if(!in_array($album, $d->field["directory"]["value"]))
      $todo[]=$album;
   }

   //add new albums
   if($todo)
   {
    $added=0;

    $d->setAction("view");
    $d->setExtra("all");

    $d->setShowFields("nr");

    $d2=Data::cache("photoalbum_categories", "add", "item");
    foreach($todo as $album)
    {
     $d2->e->clear();
     $d2->unsetValue("name");
     $d2->unsetValue("date");

     $d2->setValue("published", false); //don't publish album
     $d2->setValue("directory", $album);
     $d2->setValue("catnr", $albums); //current cate as default

     if(preg_match("!(.+/)[^/]+/$!", $album, $parent)) //get parent directory ID
     {
      $d->clearValues();
      $d->setValue("directory", $parent[1]);

      if($d->get()) //use parent directory
       $d2->setValue("catnr", $d->getValue("nr"));
     }

     if(!$d2->submit())
      $plugin->e->add($d2->e);
     else
      $added++;
    }

    $plugin->e->add($added." photo albums added automagically", "note");
   }
   else
    $plugin->e->add("No new photo albums found", "note");

   $values["timeout"]=1000; //ms
  }

  //get full album list
  $d->setAction("tree");
  $d->setExtra("down");

  $d->clearValues();

  if(!$prefix) //container
   $d->setValue("catnr", $catnr);
  else //photoalbum
  {
   $d->unsetValue("catnr"); //ensure nr is used
   $d->setValue("nr", $catnr);
  }

  $d->setShowFields("nr");
  $d->sortOrder("nr");

  if(!$d->get())
   $plugin->e->add($d->e);
  else //add all pictures
   $values["url"]=$_path["HTML"]["url"]."?pictures=".implode(";", $d->field["nr"]["value"]);

  $current=0;
  $total=0;
 }
 else
  $plugin->e->add("Unknown photo album automagic action", "error");

 //get full album name
 if($catnr&&$template->search("album", true, true, false))
 {
  $d=Data::cache("photoalbum_categories", "tree", "up");
  $d->setValue("catnr", $catnr);

  $d->setShowFields("name");

  if($d->get())
   $values["album"]=implode(" / ", $d->field["name"]["value"]);
  else
   $values["album"]="";
 }

 //set default project style sheet
 $template->setAttribute("html/head/link", "href", $_path["project"]["style"]."default.css");

 //set template values
 if($plugin->e->any())
  $values["error"]=$plugin->e->show();

 if(!$plugin->e->any("fatal"))
 {
  if($total)
   $values["percentage"]=round(100*($current/$total));
  else
   $values["percentage"]=0;

  $values["entry"]=$current;
  $values["total"]=$total;

  //calculate time
  $time=microtime(true)-$startTime;

  //calculate average time
  $tmp=$_session->get("automagic.time")*$_session->get("automagic.weigth");
  $tmp+=$time;

  if($_session->get("automagic.weigth")<10) //don't save more than 10 times
  {
   $_session->set("automagic.weigth", $_session->get("automagic.weigth")+1);
   $_session->set("automagic.time", $tmp/$_session->get("automagic.weigth"));
  }
  else
   $_session->set("automagic.time", $tmp/($_session->get("automagic.weigth")+1));

  //calculate total estimated time
  $timeLeft=$_session->get("automagic.time")*($total-$current);
  $totalTime=$_session->get("automagic.time")*$total;

  $values["time"]=round($time, 3);
  $values["timeLeft"]=gmdate("i:s", $timeLeft);
  $values["totalTime"]=gmdate("i:s", $totalTime);
 }
 else
 {
  $values["percentage"]=0;

  $values["entry"]=0;
  $values["total"]=0;

  $values["time"]=round(0, 3);
  $values["timeLeft"]=gmdate("i:s", 0);
  $values["totalTime"]=gmdate("i:s", 0);

  $template->delete("script"); //remove reload script
 }

 //set values
 $template->setReplace("html/body", $values);

 //output template
 print $template->output();
?>
