<?

 /***************************************************************************************
 * Filename: setup.php
 *
 * This file is part of the Photo album JAS plugin.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The Photo album JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/photoalbum/
 ***************************************************************************************/


 require_once($_path["include"]."fs.php");

 class Plugin_Setup_photoalbum extends Base_Plugin_Setup
 {
  function init()
  {
   global $_path;

   $this->modules();

   //copy css
   $this->mkdir($_path["project"]["style"]);
   $this->file("setup/photoalbum.css", $_path["project"]["style"]);

   //create test album
   $date=date("Y-m-d");

   $this->mkdir($_path["project"]["root"]."photoalbums");

   if(!FS::filesS($_path["project"]["root"]."photoalbums"))
   {
    $this->mkdir($_path["project"]["root"]."photoalbums/".$date." Test album");

    $this->file("setup/picture001.jpg", $_path["project"]["root"]."photoalbums/".$date." Test album/");
    $this->file("setup/picture002.jpg", $_path["project"]["root"]."photoalbums/".$date." Test album/");
    $this->file("setup/picture003.jpg", $_path["project"]["root"]."photoalbums/".$date." Test album/");
   }

   return true;
  }

  function postSetup()
  {
   $PHOTOALBUMID="PHOTOALBUM CONTAINER";
   $COMMENTID="PHOTOALBUM COMMENTS CONTAINER";

   //get root category
   $d=Data::cache("categories", "tree", "down");
   $d->setShowFields("nr");

   $d->setValue("catnr", 0);
   $d->setValue("treedepth", 0);

   if(!$d->get()||!$d->next())
   {
    $this->e->add("Root category not found");
    $this->e->add($d->e);
    return false;
   }

   $rootcatnr=$d->v["nr"];

   //get photo album category
   $d->setAction("view");
   $d->setExtra("all");
   $d->clearValues();

   $d->setShowFields("nr", "module", "moduleLock");
   $d->setValue("catnr", $rootcatnr);
   $d->setValue("text", $PHOTOALBUMID);

   if(!$d->get()||!$d->next()) //no photo album category found
   {
    //add new photo album category
    $d->setAction("add");
    $d->setExtra("item");
    $d->clearValues();
    $d->e->clear();

    $d->setValue("catnr", $rootcatnr);
    $d->setValue("name", "Photo albums");
    $d->setValue("text", $PHOTOALBUMID);

    $d->setValue("moduleLock", true);
    $d->setValue("module", Array("photoalbum_categories", "photoalbum_tags"));

    if(!$d->submit())
    {
     $this->e->add($d->e);
     return false;
    }
    else
     $this->e->add("Photo album category added", "note");

    $photoalbumcatnr=$d->getValue("nr");
   }
   else //photo album category found
   {
    //update if necessary
    $photoalbumcatnr=$d->v["nr"];

    if(
     !$d->v["moduleLock"]||
     !in_array("photoalbum_pictures", $d->v["module"])||
     !in_array("photoalbum_tags", $d->v["module"])
    )
    {
     $d->setAction("edit");
     $d->setExtra("item");
     $d->clearValues();
     $d->e->clear();

     $d->setValue("nr", $photoalbumcatnr);
     $d->setValue("moduleLock", true);
     $d->setValue("module", array_unique(array_merge($d->v["module"], Array("photoalbum_categories", "photoalbum_tags"))));

     if(!$d->submit())
     {
      $this->e->add($d->e);
      return false;
     }
     else
      $this->e->add("Photo album category updated", "note");
    }
   }

   //get photo album comments category
   $d->setAction("view");
   $d->setExtra("all");
   $d->clearValues();
   $d->e->clear();

   $d->setShowFields("nr", "module", "moduleLock");
   $d->setValue("catnr", $photoalbumcatnr);
   $d->setValue("text", $COMMENTID);

   if(!$d->get()||!$d->next()) //no photo album category found
   {
    //add new photo album category
    $d->setAction("add");
    $d->setExtra("item");
    $d->clearValues();
    $d->e->clear();

    $d->setValue("catnr", $photoalbumcatnr);
    $d->setValue("name", "Comments");
    $d->setValue("text", $COMMENTID);

    $d->setValue("moduleLock", true);
    $d->setValue("module", Array("photoalbum_comments"));

    if(!$d->submit())
    {
     $this->e->add($d->e);
     return false;
    }
    else
     $this->e->add("Photo album comments category added", "note");

    $commentscatnr=$d->getValue("nr");
   }
   else //photo album category found
   {
    //update if necessary
    $commentscatnr=$d->v["nr"];

    if(
     !$d->v["moduleLock"]||
     !in_array("photoalbum_comments", $d->v["module"])
    )
    {
     $d->setAction("edit");
     $d->setExtra("item");
     $d->clearValues();
     $d->e->clear();

     $d->setValue("nr", $commentscatnr);
     $d->setValue("moduleLock", true);
     $d->setValue("module", array_unique(array_merge($d->v["module"], Array("photoalbum_comments"))));

     if(!$d->submit())
     {
      $this->e->add($d->e);
      return false;
     }
     else
      $this->e->add("Photo album comments category updated", "note");
    }
   }


   return true;
  }

 }
?>
